<?php
/*
 * Модуль ВидеоЧекер (vchecker) v0.1
 * by progmaster
 * Skype: live:progmaster256
 * 
 */
define('DATALIFEENGINE', true);
define ( 'ROOT_DIR', dirname ( __FILE__ ) );
define ( 'ENGINE_DIR', ROOT_DIR . '/engine' );

//file_put_contents(ROOT_DIR.'/vchecker_run.txt', 'Vchecker run at '.date('c', time()));

include ENGINE_DIR . '/data/config.php';
include ENGINE_DIR . '/data/vchecker.php';
include ENGINE_DIR . '/classes/mysql.php';
include ENGINE_DIR . '/data/dbconfig.php';
include ENGINE_DIR . '/classes/mail.class.php';

$notice = '';

$query = $db->query("SELECT * FROM `".PREFIX."_post`");

/*
 * Варианты ссылок для ютуба
 * https://www.youtube.com/watch?v=kB01jVaUlNs
 * https://youtu.be/kB01jVaUlNs
 * https://www.youtube.com/embed/kB01jVaUlNs
 */

while($row = $db->get_array($query)){
    $search_string = $row['full_story'].$row['xfields'];
    $post_id = $row['id'];
    preg_match('/(youtube\.com\/watch\?v\=|youtu\.be\/|youtube\.com\/embed\/)([\w-]{11})/i', $search_string, $out);
    if(isset($out[2])){
        if(youtube_check($out[2])){
            //echo $out[2].' - OK';
        }else{
            //echo $out[2].' - FAIL';
            vchk_fail($post_id, $out[2], 'youtube');
        }
        //echo "\n";
        sleep(1);
    }

}

if(!empty($vchk['notice_email']) && !empty($notice)){
    $mail = new dle_mail($config);
    $mail->send($vchk['notice_email'], 'Обнаружена битая ссылка', $notice);
}


function vchk_fail($post_id, $link, $type='youtube'){
    global $db;
    $query = $db->query("SELECT * FROM `".PREFIX."_vchk_fail` WHERE `post_id`='".$post_id."' AND `type`='".$type."'");
    if($db->get_affected_rows()<1){
        $db->query("INSERT INTO `".PREFIX."_vchk_fail` (`post_id`, `link`, `type`) VALUES ('".$post_id."', '".$link."', '".$type."')");
        $uid = $db->insert_id();
        vchk_notice($post_id, $uid, $type);
    }else{
        $row = $db->get_row($query);
        if($row['link']!=$link){
            $db->query("UPDATE `".PREFIX."_vchk_fail` SET `link`='".$link."' WHERE `post_id`='".$post_id."' AND `type`='".$type."'");
            vchk_notice($post_id, $row['uid'], $type);
        }
    }
    return true;
}

function vchk_notice($post_id, $uid, $type='youtube'){
    global $vchk;
    global $config;
    global $notice;
    $msg = 'В посте #'.$post_id.' обнаружена битая ссылка на '.$type.'!';
    $msg .= "\nДля редактирования перейдите по ссылке: ".$config['http_home_url'].$config['admin_path'].'?mod=vchecker&edit='.$uid.'&type='.$type."\n\n";
    $notice .= $msg;
}

function youtube_check($link){
    global $vchk;
    $get = vchk_curl('https://www.googleapis.com/youtube/v3/videos?id='.$link.'&key='.$vchk['youtube_api'].'&part=snippet');
    if(!$get){
        return true;
    }    
    $get = json_decode($get, true);
    if($get['pageInfo']['totalResults']>0){
        return true;
    }else{
        return false;
    }
}


function vchk_curl($url, $post = false) {
    global $vchk;
    $ch = curl_init($url);
    curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, $vchk['curl_timeout']);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_FAILONERROR, true);
    curl_setopt($ch, CURLOPT_REFERER, 'http://'.$_SERVET['HTTP_HOST'].'/');
    curl_setopt($ch, CURLOPT_USERAGENT, 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.101 Safari/537.36');
    if($post){
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $post);
    }
    $response = curl_exec($ch);
    curl_close($ch);
    //$response = file_get_contents($url);
    if(!$response){
        return false;
    }else{
        return $response;
    }
}